%if 0%{?el7}
%define dist .el7
%endif

# git clone git://git.videolan.org/vlc.git vlc-3.0.0
# tar acvf vlc-3.0.0%%{?gitver}.tar.xz vlc-3.0.0 --exclude=.git
# cd vlc-3.0.0 ; git log -1 --pretty=format:".git%h"
%define gitver .gite043f2e
Name:           vlc
Version:        3.0.0
Release:        50%{?gitver}%{?dist}
Summary:        The cross-platform open-source multimedia framework, player and server

Packager:       momo-i <webmaster@momo-i.org>
Vendor:         momo-i, http://www.momo-i.org/

Group:          Applications/Multimedia
License:        GPLv2+
URL:            http://www.videolan.org
Source0:        http://download.videolan.org/vlc/%{version}/%{name}-%{version}%{?gitver}.tar.xz

Patch0:         vlc-3.0.0-gitremove.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# for bootstrap
BuildRequires:  autoconf automake libtool
BuildRequires:  xz gettext zlib-devel systemd-devel
BuildRequires:  dbus-devel lua-devel libgcrypt-devel
BuildRequires:  gnutls-devel gtk2-devel
BuildRequires:  gettext-devel hostname
%if 0%{?rhel} || 0%{?fedora} <= 22
BuildRequires:  prelink
%endif

BuildRequires:  libva-devel zvbi-devel SDL-devel SDL_image-devel
BuildRequires:  libdc1394-devel libraw1394-devel libavc1394-devel
BuildRequires:  libdvdread-devel libdvdnav-devel libbluray-devel
BuildRequires:  libsmbclient-devel libssh2-devel
BuildRequires:  libcdio-devel libcddb-devel
BuildRequires:  libvncserver-devel freerdp-devel game-music-emu-devel
BuildRequires:  libogg-devel libshout-devel flac-devel
BuildRequires:  opus-devel schroedinger-devel
BuildRequires:  fluidsynth-devel libkate-devel
BuildRequires:  libtiger-devel libpng-devel libtar-devel
BuildRequires:  mesa-libGL-devel mesa-libGLES-devel
BuildRequires:  xcb-util-keysyms-devel libvdpau-devel
BuildRequires:  libcaca-devel fribidi-devel
BuildRequires:  pulseaudio-libs-devel jack-audio-connection-kit-devel libsamplerate-devel
BuildRequires:  libchromaprint-devel aalib-devel
BuildRequires:  freetype-devel libXpm-devel libXext-devel libXinerama-devel
BuildRequires:  libmodplug-devel lirc-devel avahi-devel
BuildRequires:  libprojectM-devel libmtp-devel libupnp-devel
BuildRequires:  taglib-devel libidn-devel
BuildRequires:  libebml-devel libcrystalhd-devel kdelibs

BuildRequires:  libxml2-devel qt-devel
BuildRequires:  shine-devel ghc-OpenGL-devel ghc-OpenGLRaw-devel

### not exists
# alsa-oss-devel
#BuildRequires:  libsidplayfp-devel

#BuildRequires:  directfb-devel

BuildRequires:  qt-devel gnome-vfs2-devel opencv-devel libnotify-devel libass-devel librsvg2-devel
BuildRequires:  libarchive-devel libdvdnav-devel libvpx-devel mpg123-devel libjpeg-turbo-devel
BuildRequires:  mesa-libwayland-egl-devel
BuildRequires:  protobuf-lite-devel
BuildRequires:  wayland-devel >= 1.5.91
BuildRequires:  libsecret-devel soxr-devel
BuildRequires:  speex-devel
%if 0%{?fedora} >= 22
BuildRequires:  speexdsp-devel
%endif

## custom
BuildRequires:  momo-i-repos
BuildRequires:  a52dec-devel live555-devel live555 libvcd-devel
BuildRequires:  libmpeg2-devel libdvbpsi
BuildRequires:  libmad ffmpeg-devel faad2-devel twolame-devel
BuildRequires:  fdk-aac
BuildRequires:  libdca-devel dcadec libx264-devel libx265-devel
BuildRequires:  libmpcdec-devel
BuildRequires:  libdsm-devel >= 0.2.0
%ifarch x86_64
BuildRequires:	libgoom2-devel
%endif
BuildRequires:  decklink libasdcp-devel daala-devel
BuildRequires:  aribb25-devel

%description
VLC media player is a highly portable multimedia player and multimedia framework
capable of reading most audio and video formats as well as DVDs, Audio CDs VCDs,
and various streaming protocols.
It can also be used as a media converter or a server to stream in uni-cast or
multi-cast in IPv4 or IPv6 on networks.

%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package core
Summary:    VLC media player core
Group:      Applications/Multimedia
Provides:   vlc-nox = %{version}-%{release}

%description core
VLC media player core components

%prep
%setup -q
%patch0 -p1
%if 0%{?fedora} >= 25
sed -i 's,freerdp,freerdp2,g' configure.ac
%endif
./bootstrap

%build
%configure \
	--with-gnu-ld \
	--with-pic \
	--enable-optimize-memory \
	--enable-shared \
	--enable-archive \
	--enable-live555 \
	--enable-dc1394 \
	--enable-dv1394 \
	--enable-linsys \
	--enable-dvdread \
	--enable-dvdnav \
	--enable-bluray \
	--enable-opencv \
	--enable-smbclient \
	--enable-dsm \
	--enable-sftp \
	--enable-opencv \
	--enable-screen \
	--enable-vnc \
	--enable-freerdp \
	--enable-realrtsp \
	--enable-asdcp \
	--enable-dvbpsi \
	--enable-gme \
	--enable-sid=no \
	--enable-ogg \
	--enable-shout \
	--enable-wma-fixed \
	--enable-shine \
	--enable-omxil \
	--enable-omxil-vout \
	--enable-rpi-omxil \
	--enable-crystalhd \
	--enable-mad \
	--enable-mpg123 \
	--enable-merge-ffmpeg \
	--enable-gst-decode \
	--enable-avcodec \
	--enable-libva \
	--enable-dxva2 \
	--enable-d3d11va \
	--enable-vda \
	--enable-avformat \
	--enable-swscale \
	--enable-postproc \
	--enable-faad \
	--enable-vpx \
	--enable-twolame \
	--enable-fdkaac \
	--enable-a52 \
	--enable-dca \
	--enable-flac \
	--enable-libmpeg2 \
	--enable-vorbis \
	--enable-tremor \
	--enable-speex \
	--enable-opus \
	--enable-theora \
	--enable-daala \
	--enable-schroedinger \
	--enable-png \
	--enable-jpeg \
	--enable-bpg \
	--enable-x265 \
	--enable-x264 \
	--enable-fluidsynth \
	--enable-zvbi \
	--enable-telx \
	--enable-aribsub \
	--enable-aribb25 \
	--enable-kate \
	--enable-tiger \
	--enable-gles2 \
	--with-x \
	--enable-xcb \
	--enable-xvideo \
	--enable-vdpau \
	--enable-wayland \
	--enable-sdl \
	--enable-sdl-image \
	--enable-freetype \
	--enable-fribidi \
	--enable-fontconfig \
	--enable-aa \
	--enable-caca \
	--enable-kva \
	--enable-pulse \
	--enable-alsa \
	--enable-opensles \
	--enable-samplerate \
	--enable-kai \
	--enable-chromaprint \
	--enable-chromecast \
	--enable-skins2 \
	--enable-libtar \
	--enable-lirc \
%ifarch x86_64
	--enable-goom \
%endif
	--enable-projectm \
	--enable-vsxu \
	--enable-bonjour \
	--enable-udev \
	--enable-mtp \
	--enable-upnp \
	--enable-libxml2 \
	--enable-gnutls \
	--enable-run-as-root \
	--enable-skins2 \
	--enable-svg \
	--enable-svgdec \
	--enable-notify \
	--enable-libass \
	--enable-vlc

# temp
#	--enable-vcdx \

#	--enable-directfb \
#	--enable-audioqueue \
#	--enable-mfx \
#	--enable-oss \
#	--enable-gles1 \
#	--enable-quicktime \
#	--enable-mmal \

make %{?_smp_mflags} V=1
#./compile

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
find $RPM_BUILD_ROOT -name '*.a' -exec rm -f {} ';'

desktop-file-install --vendor ""            \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications   \
    --delete-original               \
    --mode 644                  \
    $RPM_BUILD_ROOT%{_datadir}/applications/vlc.desktop

# Remove installed fonts for skins2
rm -f $RPM_BUILD_ROOT%{_datadir}/vlc/skins2/fonts/*.ttf
ln -sf ../../../fonts/dejavu/DejaVuSans.ttf \
  $RPM_BUILD_ROOT%{_datadir}/vlc/skins2/fonts/FreeSans.ttf
ln -sf ../../../fonts/dejavu/DejaVuSans-Bold.ttf  \
  $RPM_BUILD_ROOT%{_datadir}/vlc/skins2/fonts/FreeSansBold.ttf

%ifarch %{ix86}
if [ -f $RPM_BUILD_ROOT%{_libdir}/vlc/plugins/codec/librealvideo_plugin.so ]
then
	execstack -c $RPM_BUILD_ROOT%{_libdir}/vlc/plugins/codec/librealvideo_plugin.so
fi
%endif

rm -rf $RPM_BUILD_ROOT%{_docdir}/vlc

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post core -p /sbin/ldconfig

%postun
%{_bindir}/update-desktop-database %{_datadir}/applications &>/dev/null
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi || :

%postun core -p /sbin/ldconfig

%posttrans core
%{_libdir}/vlc/vlc-cache-gen -f %{_libdir}/vlc &>/dev/null || :

%preun core
if [ $1 == 0 ] ; then
  rm -f %{_libdir}/vlc/plugins*.dat
fi || :

%files
%defattr(-,root,root,-)
%doc ABOUT-NLS AUTHORS INSTALL NEWS README THANKS
%{!?_licensedir:%global license %%doc}
%license COPYING*
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/kde4/apps/solid/actions/vlc-*.desktop
%{_datadir}/icons/hicolor/*/apps/vlc*.png
%{_datadir}/icons/hicolor/*/apps/vlc*.xpm
%{_datadir}/vlc/skins2/
%{_bindir}/qvlc
%{_bindir}/svlc
#{_libdir}/vlc/plugins/gui/libqt4_plugin.so
%{_libdir}/vlc/plugins/video_output/libaa_plugin.so
%{_libdir}/vlc/plugins/video_output/libcaca_plugin.so
%{_libdir}/vlc/plugins/access/libxcb_screen_plugin.so
%{_libdir}/vlc/plugins/video_output/libxcb_x11_plugin.so
%{_libdir}/vlc/plugins/video_output/libxcb_window_plugin.so
%{_libdir}/vlc/plugins/video_output/libxcb_xv_plugin.so
%{_libdir}/vlc/plugins/gui/libskins2_plugin.so
%{_libdir}/vlc/plugins/visualization/libprojectm_plugin.so
%{_libdir}/vlc/plugins/audio_output/libpulse_plugin.so

%files core -f %{name}.lang
%defattr(-,root,root,-)
%{_bindir}/vlc
%{_bindir}/vlc-wrapper
%{_bindir}/cvlc
%{_bindir}/nvlc
%{_bindir}/rvlc
%{_datadir}/vlc/
%{_libdir}/libvlc.so.*
%{_libdir}/libvlccore.so.*
%{_mandir}/man1/vlc*.1*
%{_libdir}/vlc/*
#exclude %%{_libdir}/vlc/plugins/gui/libqt4_plugin.so
%exclude %{_libdir}/vlc/plugins/video_output/libaa_plugin.so
%exclude %{_libdir}/vlc/plugins/video_output/libcaca_plugin.so
%exclude %{_libdir}/vlc/plugins/access/libxcb_screen_plugin.so
%exclude %{_libdir}/vlc/plugins/video_output/libxcb_x11_plugin.so
%exclude %{_libdir}/vlc/plugins/video_output/libxcb_window_plugin.so
%exclude %{_libdir}/vlc/plugins/video_output/libxcb_xv_plugin.so
%exclude %{_libdir}/vlc/plugins/gui/libskins2_plugin.so
%exclude %{_libdir}/vlc/plugins/visualization/libprojectm_plugin.so
%exclude %{_libdir}/vlc/plugins/audio_output/libpulse_plugin.so

%files devel
%defattr(-,root,root,-)
%{_includedir}/vlc/*.h
%{_includedir}/vlc/plugins/*.h
%{_libdir}/libvlc.so
%{_libdir}/libvlccore.so
%{_libdir}/pkgconfig/libvlc.pc
%{_libdir}/pkgconfig/vlc-plugin.pc

%changelog
* Wed Sep 07 2016 momo-i <webmaster@momo-i.org> - 3.0.0-50.gite043f2e
- Update to e043f2e

* Sat Aug 27 2016 momo-i <webmaster@momo-i.org> - 3.0.0-49.gite7a43e4
- Update to e7a43e4

* Sun Aug 21 2016 momo-i <webmaster@momo-i.org> - 3.0.0-48.git2b08663
- Update to 2b08663

* Sun Aug 14 2016 momo-i <webmaster@momo-i.org> - 3.0.0-47.git8df6a21
- Update to 8df6a21

* Sun Aug 07 2016 momo-i <webmaster@momo-i.org> - 3.0.0-46.git9dcce0a
- Update to 9dcce0a

* Wed Jul 27 2016 momo-i <webmaster@momo-i.org> - 3.0.0-45.git957d868
- Update to 957d868

* Thu Jun 30 2016 momo-i <webmaster@momo-i.org> - 3.0.0-44.gita05aba9
- Update to a05aba9

* Fri Jun 24 2016 momo-i <webmaster@momo-i.org> - 3.0.0-43.gitfeb851a
- Update to feb851a

* Wed Jun 15 2016 momo-i <webmaster@momo-i.org> - 3.0.0-42.git984edfd
- Update to 984edfd

* Tue Jun 07 2016 momo-i <webmaster@momo-i.org> - 3.0.0-41.gitf146638
- Update to f146638

* Mon May 23 2016 momo-i <webmaster@momo-i.org> - 3.0.0-40.gitb016524
- Update to b016524

* Mon May 09 2016 momo-i <webmaster@momo-i.org> - 3.0.0-39.git2244a1d
- Update to 2244a1d

* Tue Apr 26 2016 momo-i <webmaster@momo-i.org> - 3.0.0-38.gitf4e4f23
- Update to f4e4f23

* Tue Apr 26 2016 momo-i <webmaster@momo-i.org> - 3.0.0-37.git0ca42e4
- Re-enable fdk-aac for fc24

* Mon Apr 25 2016 momo-i <webmaster@momo-i.org> - 3.0.0-36.git0ca42e4
- Update to 0ca42e4

* Thu Apr 21 2016 momo-i <webmaster@momo-i.org> - 3.0.0-35.gitea82023
- Update to ea82023

* Mon Apr 04 2016 momo-i <webmaster@momo-i.org> - 3.0.0-34.git408e043
- Update to 408e043

* Wed Mar 30 2016 momo-i <webmaster@momo-i.org> - 3.0.0-33.gitc26349e
- Update to c26349e

* Mon Mar 28 2016 momo-i <webmaster@momo-i.org> - 3.0.0-32.gitd0f5a16
- Update to d0f5a16

* Fri Mar 04 2016 momo-i <webmaster@momo-i.org> - 3.0.0-31.git4757ae1
- Update to 4757ae1

* Fri Mar 04 2016 momo-i <webmaster@momo-i.org> - 3.0.0-30.git51cbbae
- Update to 51cbbae

* Wed Feb 17 2016 momo-i <webmaster@momo-i.org> - 3.0.0-29.git1bed74f
- Update to 1bed74f

* Wed Feb 10 2016 momo-i <webmaster@momo-i.org> - 3.0.0-28.gitfb98186
- Update to fb98186

* Fri Jan 15 2016 momo-i <webmaster@momo-i.org> - 3.0.0-27.gita359660
- Update to a359660

* Fri Jan 08 2016 momo-i <webmaster@momo-i.org> - 3.0.0-26.git933424d
- Update to 933424d

* Mon Jan 04 2016 momo-i <webmaster@momo-i.org> - 3.0.0-25.gita5fb9f7
- Update to a5fb9f7

* Sun Dec 27 2015 momo-i <webmaster@momo-i.org> - 3.0.0-24.gitf21453e
- Update to f21453e

* Thu Dec 24 2015 momo-i <webmaster@momo-i.org> - 3.0.0-23.git8e81483
- Update to 8e81483

* Tue Dec 15 2015 momo-i <webmaster@momo-i.org> - 3.0.0-22.git1052ee7
- Update to 1052ee7

* Mon Nov 30 2015 momo-i <webmaster@momo-i.org> - 3.0.0-21.gitbc0997a
- Update to bc0997a

* Wed Nov 25 2015 momo-i <webmaster@momo-i.org> - 3.0.0-20.git71b243f
- Update to 71b243f

* Tue Nov 17 2015 momo-i <webmaster@momo-i.org> - 3.0.0-19.git16c14cc
- Update to 16c14cc

* Fri Nov 06 2015 momo-i <webmaster@momo-i.org> - 3.0.0-18.git206a974
- Update to 206a974
- Add daala compile patch

* Mon Nov 02 2015 momo-i <webmaster@momo-i.org> - 3.0.0-17.git33ea1f2
- Update to 33ea1f2

* Tue Oct 13 2015 momo-i <webmaster@momo-i.org> - 3.0.0-16.git36cacea
- Update to 36cacea
- Rebuilt for x265

* Wed Oct 07 2015 momo-i <webmaster@momo-i.org> - 3.0.0-15.git9446c78
- Update to 9446c78

* Wed Sep 30 2015 momo-i <webmaster@momo-i.org> - 3.0.0-14.git4c0c0d3
- Update to 4c0c0d3

* Mon Sep 28 2015 momo-i <webmaster@momo-i.org> - 3.0.0-13.gita574bf3
- Update to 574bf3

* Wed Sep 16 2015 momo-i <webmaster@momo-i.org> - 3.0.0-12.git5972f56
- Update to 5972f56

* Mon Sep 07 2015 momo-i <webmaster@momo-i.org> - 3.0.0-11.gitb31df50
- Update to b31df50

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 3.0.0-10.gitd7a88fe
- Update dist for centos7

* Fri Aug 28 2015 momo-i <webmaster@momo-i.org> - 3.0.0-9.gitd7a88fe
- Update to d7a88fe

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 3.0.0-8.git7e64f62
- Rebuilt for fc23

* Tue Jul 28 2015 momo-i <webmaster@momo-i.org> - 3.0.0-7
- Update to 7e64f62
- Rebuilt for x264
- temporaly disable vcd

* Mon Jul 13 2015 momo-i <webmaster@momo-i.org> - 3.0.0-6
- Remove directfb

* Fri Jul 10 2015 momo-i <webmaster@momo-i.org> - 3.0.0-5
- Update to ae97a5a
- Add directfb
- remove compile option --enable-android-surface

* Thu Jul 02 2015 momo-i <webmaster@momo-i.org> - 3.0.0-4
- Update to 4b187ac

* Thu Jun 25 2015 momo-i <webmaster@momo-i.org> - 3.0.0-3
- Update to 5c253d5

* Fri Apr 17 2015 momo-i <webmaster@momo-i.org> - 3.0.0-2
- Rebuilt for fc22

* Fri Jan 16 2015 momo-i <webmaster@momo-i.org> - 3.0.0-1
- Initial rpm release.
